from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *
from GLRect import *

# Initial square position and size
x1 = 0.0
y1 = 0.0
rsize = 25.
# Step size in x and y directions
# (number of pixels to move each time)
xstep = 1.0
ystep = 1.0
# Keep track of windows changing width and height
windowWidth = 150.
windowHeight = 100.


def RenderScene():
    """ Called to draw scene """
    # Clear the window with current clearing color
    glClear(GL_COLOR_BUFFER_BIT)

    # Set current drawing color to red # R G B
    glColor3f(1.0, 0.0, 0.0)

    # Draw a filled rectangle with current color
    glRectf(x1, y1, x1 + rsize, y1 - rsize)

    # Flush drawing commands and swap
    glutSwapBuffers()


def TimerFunction(value):
    """ Called by GLUT library when idle (window not being resized or moved) """
    global x1,y1,rsize,xstep,ystep,windowWidth,windowHeight
    
    print "windowWidth: %d, windowHeight: %d" % (windowWidth, windowHeight)
    
    # Reverse direction when you reach left or right edge
    if (x1 > (windowWidth-rsize)) | (x1 < -windowWidth):
        xstep = -xstep
        
    # Reverse direction when you reach top or bottom edge
    if (y1 > windowHeight) | (y1 < (-windowHeight + rsize)):
        ystep = -ystep
        
    # Actually move the square
    x1 += xstep
    y1 += ystep
    
    # Check bounds. This is in case the window is made
    # smaller while the rectangle is bouncing and the
    # rectangle suddenly finds itself outside the new
    # clipping volume
    if(x1 > (windowWidth-rsize + xstep)):
        x1 = windowWidth-rsize-1
    elif(x1 < -(windowWidth + xstep)):
        x1 = - windowWidth -1
    if(y1 > (windowHeight + ystep)):
        y1 = windowHeight-1
    elif(y1 < -(windowHeight - rsize + ystep)):
        y1 = -windowHeight + rsize -1
    # Redraw the scene with new coordinates
    
    glutPostRedisplay()
    glutTimerFunc(50,TimerFunction, 1)

# Main program entry point
if __name__ == "__main__":
    glutInit()
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB)
    glutInitWindowSize(800,600)
    glutCreateWindow("Bounce")
    glutDisplayFunc(RenderScene)
    glutReshapeFunc(ChangeSize)
    glutTimerFunc(33, TimerFunction, 1)
    SetupRC()
    glutMainLoop()
