from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *

view3 = (0.0, 0.0, 6.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0)
view4 = (3.0, 0.0, 5.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0)
view1 = (3.0, 2.0, 5.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0)
view2 = (5.0, 5.0, 5.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0)
winwidth, winheigth = 0, 0


def init():
    glClearColor(1.0, 1.0, 1.0, 1.0)
    glColor3f(0.0, 0.0, 0.0)
    glShadeModel(GL_FLAT)
    glEnable(GL_SCISSOR_TEST)

def scenemodel():
    glScalef(3.0, 3.0, 3.0) #/* modeling transformation */
    glutWireCube(1.0)
    
def display():
    global view1,view2,view3,view4
    global winwidth,winheigth
    w,h = winwidth,winheigth
    aspectRatio = float(w) / float(h) 
    if (w <= h): u,v = 1,1/aspectRatio
    else: u,v = aspectRatio, 1

    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    glFrustum(-1.0*u, 1.0*u, -1.0*v, 1.0*v, 1.5, 100.0)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity() 
    
    glScissor(0, 0, w/2, h/2)
    glClear(GL_COLOR_BUFFER_BIT)
    glViewport(0, 0, w/2, h/2)
    glLoadIdentity()
    gluLookAt(*view1)
    scenemodel()
    
    glScissor(0, h/2, w/2, h/2)
    glClear(GL_COLOR_BUFFER_BIT)
    glViewport(0, h/2, w/2, h/2)
    glLoadIdentity()
    gluLookAt(*view3)
    scenemodel()
    
    glScissor(w/2, h/2, w/2, h/2)
    glClear(GL_COLOR_BUFFER_BIT)
    glViewport(w/2, h/2, w/2, h/2)
    glLoadIdentity()
    gluLookAt(*view4)
    scenemodel()

    glScissor(w/2, 0, w/2, h/2)
    glClear(GL_COLOR_BUFFER_BIT)
    glViewport(w/2, 0, w/2, h/2)
    glMatrixMode(GL_PROJECTION)
    glPushMatrix()
    glLoadIdentity()
    glOrtho(-4.0*u, 4.0*u, -4.0*v, 4.0*v, 1.5, 100.0)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()
    gluLookAt(*view2)
    scenemodel()
    glMatrixMode(GL_PROJECTION)
    glPopMatrix()
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()
  
    glFlush()

def reshape(w, h):
    global view1,view2,view3,view4
    global winwidth,winheigth
    winwidth,winheigth = w,h
    



# Main program entry point
if __name__ == "__main__":
    glutInit()
    glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB)
    glutInitWindowSize(400, 400)
    glutInitWindowPosition(0, 0)
    glutCreateWindow("cube")
    init()
    glutDisplayFunc(display)
    glutReshapeFunc(reshape)
    glutMainLoop()
