from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *

# OpenGL toolkit

def RenderScene():
    """ Called to draw scene """
    # Clear the window with current clearing color 
    glClear(GL_COLOR_BUFFER_BIT)
    
    # Set current drawing color to red # R G B 
    glColor3f(1.0, 0.0, 0.0)

    # Draw a rect
    glRectf(-100, 100, 100, -100)
    
    #...
    glColor3f(0., 0., 1.)
    glRectf(-95, 95, 95, -95)

    dim = 600.
    for x in range(int(-dim/2), int(dim/2) ,20):
        glPushMatrix()
        glTranslate(x, 0, 0)
        glColor3f((x + dim/2)/dim, (x + dim/2)/dim, (x + dim/2)/dim)
        glRectf(-5.0, 5.0, 5.0, -5.0)
        glPopMatrix()

        glPushMatrix()
        glTranslate(0, x, 0)
        glColor3f((x + dim/2)/dim, (x + dim/2)/dim, (x + dim/2)/dim)
        glRectf(-5.0, 5.0, 5.0, -5.0)
        glPopMatrix()
        
    glColor3f(0., 1., 0.)
    glRectf(-10, 10, 10, -10)
    
    # Flush drawing commands 
    glFlush() 

def SetupRC():
    """ Set up the rendering state """
    # Set clear color to blue 
    glClearColor(0.0, 0.0, 1.0, 1.0) 

def ChangeSize(w, h):
    """ Called by GLUT library when the window has changed size """
    # Prevent a divide by zero 
    if(h == 0): h = 1

    # Set Viewport to window dimensions 
    glViewport(0, 0, w, h)

    # Reset coordinate system 
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()

    # Establish clipping volume 
    # (left, right, bottom, top, near, far) 
    aspectRatio = float(w) / float(h) 
    if (w <= h):
        glOrtho (
            -100.0, 100.0, #left, rigth
            -100 / aspectRatio, 100.0 / aspectRatio, #bottom, top
            1.0, -1.0 #near, far
        )
    else: 
        glOrtho (
            -100.0 * aspectRatio, 100.0 * aspectRatio,
            -100.0, 100.0, 
            1.0, -1.0
        )

    glMatrixMode(GL_MODELVIEW) 
    glLoadIdentity() 

# Main program entry point 

if __name__ == "__main__":
    glutInit() 
    glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB) 
    glutCreateWindow("GLRect") 
    glutDisplayFunc(RenderScene) 
    glutReshapeFunc(ChangeSize) 
    SetupRC()
    glutMainLoop() 

