from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *

up_x, up_y, up_z = 0., 1., 0.

winwidth, winheigth = 0, 0



def init():
    glClearColor(1.0, 1.0, 1.0, 1.0)
    glColor3f(0.0, 0.0, 1.0)
    glShadeModel(GL_FLAT)
    glEnable(GL_SCISSOR_TEST)

def scenemodel():
    glScalef(1.5, 1.5, 1.5) #/* modeling transformation */
    glBegin(GL_QUADS);
    glColor3f(0.0,1.0,0.0)
    glVertex3f( 1.0, 1.0,-1.0)
    glVertex3f(-1.0, 1.0,-1.0)
    glVertex3f(-1.0, 1.0, 1.0)
    glVertex3f( 1.0, 1.0, 1.0)
    glColor3f(1.0,0.5,0.0)
    glVertex3f( 1.0,-1.0, 1.0)
    glVertex3f(-1.0,-1.0, 1.0)
    glVertex3f(-1.0,-1.0,-1.0)
    glVertex3f( 1.0,-1.0,-1.0)
    glColor3f(1.0,0.0,0.0)
    glVertex3f( 1.0, 1.0, 1.0)
    glVertex3f(-1.0, 1.0, 1.0)
    glVertex3f(-1.0,-1.0, 1.0)
    glVertex3f( 1.0,-1.0, 1.0)
    glColor3f(1.0,1.0,0.0)
    glVertex3f( 1.0,-1.0,-1.0)
    glVertex3f(-1.0,-1.0,-1.0)
    glVertex3f(-1.0, 1.0,-1.0)
    glVertex3f( 1.0, 1.0,-1.0)
    glColor3f(0.0,0.0,1.0)
    glVertex3f(-1.0, 1.0, 1.0)
    glVertex3f(-1.0, 1.0,-1.0)
    glVertex3f(-1.0,-1.0,-1.0)
    glVertex3f(-1.0,-1.0, 1.0)
    glColor3f(1.0,0.0,1.0)
    glVertex3f( 1.0, 1.0,-1.0)
    glVertex3f( 1.0, 1.0, 1.0)
    glVertex3f( 1.0,-1.0, 1.0)
    glVertex3f( 1.0,-1.0,-1.0)
    glEnd()

    glPushMatrix()
    glScalef(2, 2, 2)
    glColor3f(1.0, 1.0, 1.0)
    glutWireCube(1.0)
    glPopMatrix()
    glutSwapBuffers()
    
def display():
    
    global winwidth,winheigth
    w,h = winwidth,winheigth
    
    view3 = (0.0, 0.0, 6.0, 0.0, 0.0, 0.0, up_x, up_y, up_z)
    view4 = (3.0, 0.0, 5.0, 0.0, 0.0, 0.0, up_x, up_y, up_z)
    view1 = (3.0, 2.0, 5.0, 0.0, 0.0, 0.0, up_x, up_y, up_z)
    view2 = (5.0, 5.0, 5.0, 0.0, 0.0, 0.0, up_x, up_y, up_z)

    aspectRatio = float(w) / float(h) 
    if (w <= h): u,v = 1,1/aspectRatio
    else: u,v = aspectRatio, 1

    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    glFrustum(-1.0*u, 1.0*u, -1.0*v, 1.0*v, 1.5, 10.0)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity() 
    
    glScissor(0, 0, w/2, h/2)
    glClear(GL_COLOR_BUFFER_BIT)
    glViewport(0, 0, w/2, h/2)
    glLoadIdentity()
    gluLookAt(*view1)
    scenemodel()
    
    glScissor(0, h/2, w/2, h/2)
    glClear(GL_COLOR_BUFFER_BIT)
    glViewport(0, h/2, w/2, h/2)
    glLoadIdentity()
    gluLookAt(*view3)
    scenemodel()
    
    glScissor(w/2, h/2, w/2, h/2)
    glClear(GL_COLOR_BUFFER_BIT)
    glViewport(w/2, h/2, w/2, h/2)
    glLoadIdentity()
    gluLookAt(*view4)
    scenemodel()

    glScissor(w/2, 0, w/2, h/2)
    glClear(GL_COLOR_BUFFER_BIT)
    glViewport(w/2, 0, w/2, h/2)
    glMatrixMode(GL_PROJECTION)
    glPushMatrix()
    glLoadIdentity()
    glOrtho(-4.0*u, 4.0*u, -4.0*v, 4.0*v, 0.1, 100.0)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()
    gluLookAt(*view2)
    scenemodel()
    glMatrixMode(GL_PROJECTION)
    glPopMatrix()
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()

    glutSwapBuffers()


def reshape(w, h):
    global view1,view2,view3,view4
    global winwidth,winheigth
    winwidth,winheigth = w,h
    display()
    
def keyfunc(key, x, y):
    global up_x, up_y, up_z
   
    if key == 'a':
        up_x -= 0.1
    if key == 'q':
        up_x += 0.1
    if key == 's':
        up_y -= 0.1
    if key == 'w':
        up_y += 0.1
    if key == 'd':
        up_z -= 0.1
    if key == 'e':
        up_z += 0.1
    
    print "view up vector: [%f, %f, %f]" % (up_x, up_y, up_z)
    glutPostRedisplay()

# Main program entry point
if __name__ == "__main__":
    glutInit()
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB)
    glutInitWindowSize(400, 400)
    glutInitWindowPosition(0, 0)
    glutCreateWindow("Changing VUV...")
    init()
    glutDisplayFunc(display)
    glutKeyboardFunc(keyfunc)
    glutReshapeFunc(reshape)
    glutMainLoop()
